// Auto-generated. Do not edit!

// (in-package mbf_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let nav_msgs = _finder('nav_msgs');

//-----------------------------------------------------------

class ExePathGoal {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.path = null;
      this.controller = null;
      this.concurrency_slot = null;
      this.tolerance_from_action = null;
      this.dist_tolerance = null;
      this.angle_tolerance = null;
    }
    else {
      if (initObj.hasOwnProperty('path')) {
        this.path = initObj.path
      }
      else {
        this.path = new nav_msgs.msg.Path();
      }
      if (initObj.hasOwnProperty('controller')) {
        this.controller = initObj.controller
      }
      else {
        this.controller = '';
      }
      if (initObj.hasOwnProperty('concurrency_slot')) {
        this.concurrency_slot = initObj.concurrency_slot
      }
      else {
        this.concurrency_slot = 0;
      }
      if (initObj.hasOwnProperty('tolerance_from_action')) {
        this.tolerance_from_action = initObj.tolerance_from_action
      }
      else {
        this.tolerance_from_action = false;
      }
      if (initObj.hasOwnProperty('dist_tolerance')) {
        this.dist_tolerance = initObj.dist_tolerance
      }
      else {
        this.dist_tolerance = 0.0;
      }
      if (initObj.hasOwnProperty('angle_tolerance')) {
        this.angle_tolerance = initObj.angle_tolerance
      }
      else {
        this.angle_tolerance = 0.0;
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type ExePathGoal
    // Serialize message field [path]
    bufferOffset = nav_msgs.msg.Path.serialize(obj.path, buffer, bufferOffset);
    // Serialize message field [controller]
    bufferOffset = _serializer.string(obj.controller, buffer, bufferOffset);
    // Serialize message field [concurrency_slot]
    bufferOffset = _serializer.uint8(obj.concurrency_slot, buffer, bufferOffset);
    // Serialize message field [tolerance_from_action]
    bufferOffset = _serializer.bool(obj.tolerance_from_action, buffer, bufferOffset);
    // Serialize message field [dist_tolerance]
    bufferOffset = _serializer.float32(obj.dist_tolerance, buffer, bufferOffset);
    // Serialize message field [angle_tolerance]
    bufferOffset = _serializer.float32(obj.angle_tolerance, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type ExePathGoal
    let len;
    let data = new ExePathGoal(null);
    // Deserialize message field [path]
    data.path = nav_msgs.msg.Path.deserialize(buffer, bufferOffset);
    // Deserialize message field [controller]
    data.controller = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [concurrency_slot]
    data.concurrency_slot = _deserializer.uint8(buffer, bufferOffset);
    // Deserialize message field [tolerance_from_action]
    data.tolerance_from_action = _deserializer.bool(buffer, bufferOffset);
    // Deserialize message field [dist_tolerance]
    data.dist_tolerance = _deserializer.float32(buffer, bufferOffset);
    // Deserialize message field [angle_tolerance]
    data.angle_tolerance = _deserializer.float32(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += nav_msgs.msg.Path.getMessageSize(object.path);
    length += object.controller.length;
    return length + 14;
  }

  static datatype() {
    // Returns string type for a message object
    return 'mbf_msgs/ExePathGoal';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '997d05ac3260fea4e2e2586ca47d2578';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======
    # Follow the given path until completion or failure
    
    nav_msgs/Path path
    
    # Controller to use; defaults to the first one specified on "controllers" parameter
    string controller
    
    # use different slots for concurrency
    uint8 concurrency_slot
    
    # define goal tolerance for the action
    bool tolerance_from_action
    float32 dist_tolerance
    float32 angle_tolerance
    
    ================================================================================
    MSG: nav_msgs/Path
    #An array of poses that represents a Path for a robot to follow
    Header header
    geometry_msgs/PoseStamped[] poses
    
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    # 0: no frame
    # 1: global frame
    string frame_id
    
    ================================================================================
    MSG: geometry_msgs/PoseStamped
    # A Pose with reference coordinate frame and timestamp
    Header header
    Pose pose
    
    ================================================================================
    MSG: geometry_msgs/Pose
    # A representation of pose in free space, composed of position and orientation. 
    Point position
    Quaternion orientation
    
    ================================================================================
    MSG: geometry_msgs/Point
    # This contains the position of a point in free space
    float64 x
    float64 y
    float64 z
    
    ================================================================================
    MSG: geometry_msgs/Quaternion
    # This represents an orientation in free space in quaternion form.
    
    float64 x
    float64 y
    float64 z
    float64 w
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new ExePathGoal(null);
    if (msg.path !== undefined) {
      resolved.path = nav_msgs.msg.Path.Resolve(msg.path)
    }
    else {
      resolved.path = new nav_msgs.msg.Path()
    }

    if (msg.controller !== undefined) {
      resolved.controller = msg.controller;
    }
    else {
      resolved.controller = ''
    }

    if (msg.concurrency_slot !== undefined) {
      resolved.concurrency_slot = msg.concurrency_slot;
    }
    else {
      resolved.concurrency_slot = 0
    }

    if (msg.tolerance_from_action !== undefined) {
      resolved.tolerance_from_action = msg.tolerance_from_action;
    }
    else {
      resolved.tolerance_from_action = false
    }

    if (msg.dist_tolerance !== undefined) {
      resolved.dist_tolerance = msg.dist_tolerance;
    }
    else {
      resolved.dist_tolerance = 0.0
    }

    if (msg.angle_tolerance !== undefined) {
      resolved.angle_tolerance = msg.angle_tolerance;
    }
    else {
      resolved.angle_tolerance = 0.0
    }

    return resolved;
    }
};

module.exports = ExePathGoal;
